> For the complete documentation index, see [llms.txt](https://docs.zingg.ai/zingg/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.zingg.ai/zingg/versions/community-v0.5.0/stepbystep/configuration/adv-matchtypes.md).

# Advanced Match Types

Defining match types to support generic mappings as well as get domain knowledge

[Zingg Enterprise Feature](#user-content-fn-1)[^1]

**Advanced matchType**

We come across many cases where multiple entities all map to a single entity or a single entity can be used in place of them. This may be in cases such as nicknames, company abbreviations and gender among others. For example, we have multiple records with nicknames such as \["Will", "Bill", "William"], \["John", "Johnny", "Jack"] where each set of map links to one person. So in this case, Will will map to William, Bill will map to William and all of them will be assigned to the same cluster given the rest of the fields also match. So, we can support generic mappings and help increasing domain knowledge as well.

Here, a json containing all mappings such as \[“Will”, “Bill”, “William”], \[“IBM", "International Business Machine”], \["0", "M", "Male"] needs to be created and stored according to user's requirement. For example, we make a json for company abbreviations and store is as `companies.json`. They will be added in the config as **MAPPING\_COMPANIES** along with other match types for the required field.

This way we can match the given field on multiple criteria such as nicknames and abbreviations. Multiple match types, separated by commas, can also be used. For example **MAPPING\_COMPANIES**, **FUZZY** and **NULL\_OR\_BLANK** can be used for a single field.

```json
"fieldDefinition":[
   	{
   		"fieldName" : "name",
   		"matchType" : "mapping_companies,exact",
   		"fields" : "name",
   		"dataType": "string"
   	},
```

### The mapping match type can be integrated as follows:

`export ZINGG_CONF_HOME=<path to json with abbreviations>`

### Example nicknames\_test.json:

```json
[  
  ["Will", "Bill", "William"],
  ["John", "Johnny", "Jack"],
  ["Robert", "Rob", "Bob", "Bobby"],
  ["Charles", "Charlie", "Chuck"],
  ["James", "Jim", "Jimmy"],
  ["Thomas", "Tom", "Tommy"]
...
]   
```

[^1]: Zingg Enterprise is an advance version of Zingg Community with production grade features


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.zingg.ai/zingg/versions/community-v0.5.0/stepbystep/configuration/adv-matchtypes.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
